/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * WALPO.java
 *
 * Created on 07-abr-2012, 15:45:53
 */

package walpo;

import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
import org.jdesktop.application.Action;
import walpo.auxiliares.FiltroArchivos;
import walpo.negocio.TratarArchivo;

/**
 *
 * @author Antonio López
 */
public class WALPO extends javax.swing.JPanel {

    private TratarArchivo tratarArchivo;

    private static final String SALTO_LINEA = "\n";

    private File archivo;

    /** Creates new form WALP */
    public WALPO() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btnAbrirFicheroInicial = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        txRegistroEventos = new javax.swing.JTextArea();
        btnGenerarFicheroIntermedio = new javax.swing.JButton();
        btnGenerarFicheroFinal = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();

        setName("Form"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(walpo.WALPOApp.class).getContext().getActionMap(WALPO.class, this);
        btnAbrirFicheroInicial.setAction(actionMap.get("abrirFicheroInicial")); // NOI18N
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(walpo.WALPOApp.class).getContext().getResourceMap(WALPO.class);
        btnAbrirFicheroInicial.setText(resourceMap.getString("btnAbrirFicheroInicial.text")); // NOI18N
        btnAbrirFicheroInicial.setMaximumSize(new java.awt.Dimension(120, 23));
        btnAbrirFicheroInicial.setMinimumSize(new java.awt.Dimension(120, 23));
        btnAbrirFicheroInicial.setName("btnAbrirFicheroInicial"); // NOI18N
        btnAbrirFicheroInicial.setPreferredSize(new java.awt.Dimension(120, 23));

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        txRegistroEventos.setColumns(20);
        txRegistroEventos.setEditable(false);
        txRegistroEventos.setRows(5);
        txRegistroEventos.setName("txRegistroEventos"); // NOI18N
        jScrollPane1.setViewportView(txRegistroEventos);

        btnGenerarFicheroIntermedio.setAction(actionMap.get("generarFicheroIntermedio")); // NOI18N
        btnGenerarFicheroIntermedio.setText(resourceMap.getString("btnGenerarFicheroIntermedio.text")); // NOI18N
        btnGenerarFicheroIntermedio.setEnabled(false);
        btnGenerarFicheroIntermedio.setName("btnGenerarFicheroIntermedio"); // NOI18N

        btnGenerarFicheroFinal.setAction(actionMap.get("generarFicheroFinal")); // NOI18N
        btnGenerarFicheroFinal.setText(resourceMap.getString("btnGenerarFicheroFinal.text")); // NOI18N
        btnGenerarFicheroFinal.setEnabled(false);
        btnGenerarFicheroFinal.setName("btnGenerarFicheroFinal"); // NOI18N

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(btnGenerarFicheroFinal, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 893, Short.MAX_VALUE)
                    .addComponent(btnGenerarFicheroIntermedio, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 893, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 893, Short.MAX_VALUE)
                    .addComponent(btnAbrirFicheroInicial, javax.swing.GroupLayout.DEFAULT_SIZE, 893, Short.MAX_VALUE)
                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(btnAbrirFicheroInicial, javax.swing.GroupLayout.PREFERRED_SIZE, 55, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnGenerarFicheroIntermedio, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnGenerarFicheroFinal, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 262, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Acción que posibilita la selección y apertura de un archivo a través de un
     * control JFileChooser.
     */
    @Action
    public void abrirFicheroInicial() {

        //Crear una ventana para la selección de archivos
        final JFileChooser fc = new JFileChooser();

        //Recuperar, si existe, la última ruta usada
        if (this.archivo != null) {
            fc.setCurrentDirectory(archivo);
        }

        //Fijar los tipos de archivo que se pueden abrir
        FileFilter ff = new FiltroArchivos(FiltroArchivos.DESCRIPCION_EXTENSION_LOG, FiltroArchivos.EXTENSION_LOG);
        fc.setFileFilter(ff);
        fc.setAcceptAllFileFilterUsed(false);

        //Abrir el selector de archivos y recoger lo que ha hecho el usuario con él
        int resultado = fc.showOpenDialog(WALPO.this);
        
        if (resultado == JFileChooser.APPROVE_OPTION) { //El usuario ha confirmado la apertura del archivo

            //Abrir el archivo seleccionarlo y almacenarlo temporalmente
            archivo = fc.getSelectedFile();
            txRegistroEventos.append("Abriendo el fichero inicial " + archivo.getName() + "..." + SALTO_LINEA);
            txRegistroEventos.append("Fichero inicial " + archivo.getName() + " abierto correctamente." + SALTO_LINEA);
            
            try {
                
                //Leer el archivo y procesarlo para guardarlo en memoria
                txRegistroEventos.append("Procesando el fichero inicial" + archivo.getName() + "..." + SALTO_LINEA);
                txRegistroEventos.update(txRegistroEventos.getGraphics()); //Refrescar el área de texto
                this.tratarArchivo = new TratarArchivo(this.archivo);
                txRegistroEventos.append("Fichero inicial " + archivo.getName() + " procesado correctamente." + SALTO_LINEA);

                this.btnGenerarFicheroIntermedio.setEnabled(true);

            } catch (Exception ex) {
                txRegistroEventos.append("Se ha producido una excepción: " + ex + SALTO_LINEA);
                Logger.getLogger(WALPO.class.getName()).log(Level.SEVERE, null, ex);
            }
            
        } else { //El usuario ha cancelado la apeertura del archivo

            txRegistroEventos.append("El usuario ha cancelado la apertura del fichero." + SALTO_LINEA);
        }

        txRegistroEventos.setCaretPosition(txRegistroEventos.getText().length() - 1); //Posicionarse en la última línea
    }

    /**
     * Procesar el fichero leido y transformarlo en un fichero intermedio en formato CSV.
     */
    @Action
    public void generarFicheroIntermedio() {

        try {

            //Inicio del proceso de generación del fichero intermedio
            txRegistroEventos.append(SALTO_LINEA + "------------------------------------------------------" + SALTO_LINEA);
            txRegistroEventos.append("Generando el fichero intermedio..." + SALTO_LINEA);

            //1. Eliminación de líneas no necesarias
            txRegistroEventos.append("Eliminando líneas no necesarias de " + archivo.getName() + "..." + SALTO_LINEA);
            txRegistroEventos.update(txRegistroEventos.getGraphics()); //Refrescar el área de texto
            this.tratarArchivo.eliminarLineasNoNecesarias();
            txRegistroEventos.append("Eliminación de líneas no necesarias realizada correctamente." + SALTO_LINEA);

            //2. Tratamiento de sesiones
            txRegistroEventos.append("Obteniendo los identificadores de sesión..." + SALTO_LINEA);
            txRegistroEventos.update(txRegistroEventos.getGraphics()); //Refrescar el área de texto
            this.tratarArchivo.tratarSesiones();
            txRegistroEventos.append("Identificadores de sesión obtenidos correctamente." + SALTO_LINEA);

            //3. Tratamiento de las URL de los recursos solicitados
            txRegistroEventos.append("Procesando las URL de los recursos solicitados..." + SALTO_LINEA);
            txRegistroEventos.update(txRegistroEventos.getGraphics()); //Refrescar el área de texto
            this.tratarArchivo.tratarUrlRecursoSolicitado();
            txRegistroEventos.append("URL de los recursos solicitados procesadas correctamente." + SALTO_LINEA);

            //Para que el algoritmo sea más óptimo, los siguientes pasos del proceso se ejecutan a la vez:
            //4. Eliminación de los elementos (columnas) no necesarios
            //5. Identificación de elementos
            //6. Conversión a formato CSV (Comma Separated Values)
            txRegistroEventos.append("Transformando " + archivo.getName() + " a formato CSV..." + SALTO_LINEA);
            txRegistroEventos.update(txRegistroEventos.getGraphics()); //Refrescar el área de texto
            this.tratarArchivo.transformarCsvIntermedio();
            txRegistroEventos.append(archivo.getName() + " transformado a formato CSV correctamente." + SALTO_LINEA);

            //Finalización del proceso de generación del fichero intermedio
            txRegistroEventos.append("El fichero intermedio se ha generado correctamente conteniendo " +
                    this.tratarArchivo.getTotalLineasAceptadas() + " líneas." + SALTO_LINEA);
            txRegistroEventos.append("Se han descartado " + this.tratarArchivo.getTotalLineasDescartadas() + " líneas de un total de " +
                    this.tratarArchivo.getTotalLineas() + " existentes en el fichero inicial."  + SALTO_LINEA);
            txRegistroEventos.append("------------------------------------------------------" + SALTO_LINEA);

            this.btnGenerarFicheroFinal.setEnabled(true);

        } catch (IOException ex) {
            txRegistroEventos.append("Se ha producido una excepción al generar el fichero intermedio: " + ex + SALTO_LINEA);
            Logger.getLogger(WALPO.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            txRegistroEventos.setCaretPosition(txRegistroEventos.getText().length() - 1);  //Posicionarse en la última línea
        }
    }

    /**
     * A partir de lo almacenado en el fichero intermedio, general el fichero final en formato CSV y
     * la estructura necesaria para el estudio.
     */
    @Action
    public void generarFicheroFinal() {

        try {

        //Inicio del proceso de generación del fichero final
        txRegistroEventos.append(SALTO_LINEA + "------------------------------------------------------" + SALTO_LINEA);
        txRegistroEventos.append("Generando el fichero final..." + SALTO_LINEA);

        //7. Determinar de forma única la lista de recursos solicitados
        txRegistroEventos.append("Determinando el conjunto de recursos solicitados..." + SALTO_LINEA);
        txRegistroEventos.update(txRegistroEventos.getGraphics()); //Refrescar el área de texto
        this.tratarArchivo.identificarRecursosSolicitados();
        txRegistroEventos.append("Recursos solicitados determinados correctamente." + SALTO_LINEA);

        //8. Determinar las secuencias de navegación
        txRegistroEventos.append("Determinando las secuencias de navegación..." + SALTO_LINEA);
        txRegistroEventos.update(txRegistroEventos.getGraphics()); //Refrescar el área de texto
        this.tratarArchivo.determinarSecuenciasNavegacion();
        txRegistroEventos.append("Secuencias de navegación determinadas correctamente." + SALTO_LINEA);

        //Para que el algoritmo sea más óptimo, los siguientes pasos del proceso se ejecutan a la vez:
        //9. Identificación de elementos
        //10. Conversión a formato CSV (Comma Separated Values)
        txRegistroEventos.append("Realizando la transformación a formato CSV..." + SALTO_LINEA);
        txRegistroEventos.update(txRegistroEventos.getGraphics()); //Refrescar el área de texto
        this.tratarArchivo.transformarCsvFinal();
        txRegistroEventos.append("Transformación a formato CSV realizada correctamente." + SALTO_LINEA);

        //Finalización del proceso de generación del fichero intermedio
        txRegistroEventos.append("El fichero final se ha generado correctamente." + SALTO_LINEA);
        txRegistroEventos.append("------------------------------------------------------" + SALTO_LINEA);

        } catch (IOException ex) {
            txRegistroEventos.append("Se ha producido una excepción al generar el fichero final: " + ex + SALTO_LINEA);
            Logger.getLogger(WALPO.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            txRegistroEventos.setCaretPosition(txRegistroEventos.getText().length() - 1);  //Posicionarse en la última línea
        }
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAbrirFicheroInicial;
    private javax.swing.JButton btnGenerarFicheroFinal;
    private javax.swing.JButton btnGenerarFicheroIntermedio;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea txRegistroEventos;
    // End of variables declaration//GEN-END:variables

}
