/*
 * WALPO: Web Access Logs Preprocessing Tool
 *
 * WALPAOpp.java
 */

package walpo;

import org.jdesktop.application.Application;
import org.jdesktop.application.SingleFrameApplication;

/**
 * The main class of the application.
 *
 * IMPORTANTE!!! Para ejecutar, fijar al menos estos parámetros para la JVM: -Xmx800m -Xms128m
 * Des esta forma se podrá trabajar con ficheros de log de al menos 256 MB.
 */
public class WALPOApp extends SingleFrameApplication {

    /**
     * At startup create and show the main frame of the application.
     */
    @Override protected void startup() {
        show(new WALPO());
    }

    /**
     * This method is to initialize the specified window by injecting resources.
     * Windows shown in our application come fully initialized from the GUI
     * builder, so this additional configuration is not needed.
     */
    @Override protected void configureWindow(java.awt.Window root) {
    }

    /**
     * A convenient static getter for the application instance.
     * @return the instance of WALPApp
     */
    public static WALPOApp getApplication() {
        return Application.getInstance(WALPOApp.class);
    }

    /**
     * Main method launching the application.
     */
    public static void main(String[] args) {
        launch(WALPOApp.class, args);
    }
}
