/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package walpo.auxiliares;

import java.util.logging.ConsoleHandler;
import java.util.logging.Handler;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Antonio López
 */
public class ConfigurarLog {

    private Logger log;
    
    public ConfigurarLog(Logger log) {
        this.log = log;
    }

    /**
     * Fijar un nivel de log tanto para el log indicado como para la consola.
     * Nivel de log: Level.ALL para habilitar, Level.OFF para deshabilitar. *
     * @param nivel
     */
    public void setLevel(Level nivel) {

        //get the top Logger:
        Logger topLogger = java.util.logging.Logger.getLogger("");

        // Handler for console (reuse it if it already exists)
        Handler consoleHandler = null;
        //see if there is already a console handler
        for (Handler handler : topLogger.getHandlers()) {
            if (handler instanceof ConsoleHandler) {
                //found the console handler
                consoleHandler = handler;
                break;
            }
        }

        if (consoleHandler == null) {
            //there was no console handler found, create a new one
            consoleHandler = new ConsoleHandler();
            topLogger.addHandler(consoleHandler);
        }
        //set the console handler:
        consoleHandler.setLevel(nivel);
        //set de selected log handler
        this.log.setLevel(nivel);
    }
}
