/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package walpo.auxiliares;

import java.io.File;
import javax.swing.filechooser.FileFilter;

/**
 *
 * @author Antonio López
 */
public class FiltroArchivos extends FileFilter {

    public static final String DESCRIPCION_EXTENSION_LOG = "Archivos de log";
    public static final String EXTENSION_LOG = "LOG";

    private String descripcion;
    private String extensiones[];


    public FiltroArchivos(String descripcion, String extension) {
        this(descripcion, new String[] {extension});
    }

    public FiltroArchivos(String descripcion, String extensiones[]) {

        if (descripcion == null) {
            this.descripcion = extensiones[0];
        } else {
            this.descripcion = descripcion;
        }

        this.extensiones = (String[]) extensiones.clone();
        toLower(this.extensiones);
    }

    private void toLower(String array[]) {

        for (int i = 0, n = array.length; i < n; i++) {
            array[i] = array[i].toLowerCase();
        }
    }

    public String getDescription() { return descripcion; }

    public boolean accept(File file) {

        if (file.isDirectory()) { return true; }
        else {
            
            String path = file.getAbsolutePath().toLowerCase();
            for (int i = 0, n = extensiones.length; i < n; i++) {

                String extension = extensiones[i];
                if ((path.endsWith(extension) && (path.charAt(path.length() - extension.length() - 1)) == '.')) {
                  return true;
                }
            }
        }

        return false;
    }
}
