
package walpo.modelo;

/**
 * Clase para la persistencia de una línea de log.
 * 
 * @author Antonio López
 */
public class LineaLog {

    public static final String CARACTER_COMA = ",";
    public static final String CARACTER_ESPACIO = " ";

    public static final String NO_ID_SESION = "NO_ID";

    private String fechaHora;
    private String direccionIP;    
    private String metodoPeticion;
    private String recursoSolicitado;
    private String protocolo;
    private String codigoRespuesta;
    private String rutaOrigen;
    private String navegador;
    private String bytesObtenidos;
    private String p1;

    private String idSesion;

    /**
     * @return the fechaHora
     */
    public String getFechaHora() {
        return fechaHora;
    }

    /**
     * @param fechaHora the fechaHora to set
     */
    public void setFechaHora(String fechaHora) {
        this.fechaHora = fechaHora;
    }

    /**
     * @return the direccionIP
     */
    public String getDireccionIP() {
        return direccionIP;
    }

    /**
     * @param direccionIP the direccionIP to set
     */
    public void setDireccionIP(String direccionIP) {
        this.direccionIP = direccionIP;
    }

    /**
     * @return the metodoPeticion
     */
    public String getMetodoPeticion() {
        return metodoPeticion;
    }

    /**
     * @param metodoPeticion the metodoPeticion to set
     */
    public void setMetodoPeticion(String metodoPeticion) {
        this.metodoPeticion = metodoPeticion;
    }

    /**
     * @return the recursoSolicitado
     */
    public String getRecursoSolicitado() {
        return recursoSolicitado;
    }

    /**
     * @param recursoSolicitado the recursoSolicitado to set
     */
    public void setRecursoSolicitado(String recursoSolicitado) {
        this.recursoSolicitado = recursoSolicitado;
    }

    /**
     * @return the protocolo
     */
    public String getProtocolo() {
        return protocolo;
    }

    /**
     * @param protocolo the protocolo to set
     */
    public void setProtocolo(String protocolo) {
        this.protocolo = protocolo;
    }

    /**
     * @return the codigoRespuesta
     */
    public String getCodigoRespuesta() {
        return codigoRespuesta;
    }

    /**
     * @param codigoRespuesta the codigoRespuesta to set
     */
    public void setCodigoRespuesta(String codigoRespuesta) {
        this.codigoRespuesta = codigoRespuesta;
    }

    /**
     * @return the rutaOrigen
     */
    public String getRutaOrigen() {
        return rutaOrigen;
    }

    /**
     * @param rutaOrigen the rutaOrigen to set
     */
    public void setRutaOrigen(String rutaOrigen) {
        this.rutaOrigen = rutaOrigen;
    }

    /**
     * @return the navegador
     */
    public String getNavegador() {
        return navegador;
    }

    /**
     * @param navegador the navegador to set
     */
    public void setNavegador(String navegador) {
        this.navegador = navegador;
    }

    /**
     * @return the bytesObtenidos
     */
    public String getBytesObtenidos() {
        return bytesObtenidos;
    }

    /**
     * @param bytesObtenidos the bytesObtenidos to set
     */
    public void setBytesObtenidos(String bytesObtenidos) {
        this.bytesObtenidos = bytesObtenidos;
    }

    /**
     * @return the p1
     */
    public String getP1() {
        return p1;
    }

    /**
     * @param p1 the p1 to set
     */
    public void setP1(String p1) {
        this.p1 = p1;
    }

    /**
     * @return the idSesion
     */
    public String getIdSesion() {
        return idSesion;
    }

    /**
     * @param idSesion the idSesion to set
     */
    public void setIdSesion(String idSesion) {
        this.idSesion = idSesion;
    }

    /**
     * Definir una línea con el formato y separador indicados, considerando todos los
     * elementos de la misma.
     * @param separador
     * @return
     */
    public String getLineaLog(String separador) {

        return this.getFechaHora() + separador + this.getDireccionIP() + separador + this.getMetodoPeticion() + separador +
                this.getRecursoSolicitado() + separador + this.getProtocolo() + separador + this.getCodigoRespuesta() + separador +
                this.getRutaOrigen() + separador + this.getNavegador() + separador + this.getBytesObtenidos() + separador + this.getP1();
    }

    /**
     * Definir una línea con el formato y separador indicados, considerando únicamente
     * un subconjunto del total de elementos de la misma.
     * @param separador
     * @return
     */
    public String getLineaLogParcial(String separador) {

        return this.getDireccionIP() + separador + this.getRecursoSolicitado() + separador + this.getIdSesion();
    }
}
